Create credits by order number - Fabric

Create credits by order number

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/create-credits \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-channel-id: <x-fabric-channel-id>' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "credits": [
    {
      "amount": 21.5,
      "currency": "USD",
      "reasonCode": "EC",
      "source": "CSR",
      "type": "GIFT_CARD",
      "amountInCurrencies": [
        {
          "currency": "USD",
          "group": "SHOPPER",
          "amount": 123.45
        }
      ],
      "attributes": {
        "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ"
      },
      "employeeId": "12312232",
      "note": "Credit request initiated",
      "paymentCounter": 1,
      "policyCode": "RC1",
      "subReasonCode": "ACC"
    }
  ]
}
'

Python

import requests

url = "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/create-credits"

payload = { "credits": [
        {
            "amount": 21.5,
            "currency": "USD",
            "reasonCode": "EC",
            "source": "CSR",
            "type": "GIFT_CARD",
            "amountInCurrencies": [
                {
                    "currency": "USD",
                    "group": "SHOPPER",
                    "amount": 123.45
                }
            ],
            "attributes": { "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ" },
            "employeeId": "12312232",
            "note": "Credit request initiated",
            "paymentCounter": 1,
            "policyCode": "RC1",
            "subReasonCode": "ACC"
        }
    ] }
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "x-fabric-channel-id": "<x-fabric-channel-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    'x-fabric-channel-id': '<x-fabric-channel-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    credits: [
      {
        amount: 21.5,
        currency: 'USD',
        reasonCode: 'EC',
        source: 'CSR',
        type: 'GIFT_CARD',
        amountInCurrencies: [{currency: 'USD', group: 'SHOPPER', amount: 123.45}],
        attributes: {giftCardNumber: 'XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ'},
        employeeId: '12312232',
        note: 'Credit request initiated',
        paymentCounter: 1,
        policyCode: 'RC1',
        subReasonCode: 'ACC'
      }
    ]
  })
};

fetch('https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/create-credits', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/create-credits",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'credits' => [
        [
                'amount' => 21.5,
                'currency' => 'USD',
                'reasonCode' => 'EC',
                'source' => 'CSR',
                'type' => 'GIFT_CARD',
                'amountInCurrencies' => [
                                [
                                                                'currency' => 'USD',
                                                                'group' => 'SHOPPER',
                                                                'amount' => 123.45
                                ]
                ],
                'attributes' => [
                                'giftCardNumber' => 'XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ'
                ],
                'employeeId' => '12312232',
                'note' => 'Credit request initiated',
                'paymentCounter' => 1,
                'policyCode' => 'RC1',
                'subReasonCode' => 'ACC'
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-channel-id: <x-fabric-channel-id>",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/orders/order-number/{orderNumber}/actions/create-credits"

payload := strings.NewReader(`{
  "credits": [
    {
      "amount": 21.5,
      "currency": "USD",
      "reasonCode": "EC",
      "source": "CSR",
      "type": "GIFT_CARD",
      "amountInCurrencies": [
        {
          "currency": "USD",
          "group": "SHOPPER",
          "amount": 123.45
        }
      ],
      "attributes": {
        "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ"
      },
      "employeeId": "12312232",
      "note": "Credit request initiated",
      "paymentCounter": 1,
      "policyCode": "RC1",
      "subReasonCode": "ACC"
    }
  ]
}`)

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("x-fabric-channel-id", "<x-fabric-channel-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Examples

Success Response (200)

{
  "credits": [
    {
      "amount": 21.5,
      "currency": "USD",
      "reasonCode": "EC",
      "source": "CSR",
      "type": "GIFT_CARD",
      "amountInCurrencies": [
        {
          "currency": "USD",
          "group": "SHOPPER",
          "amount": 123.45
        }
      ],
      "attributes": {
        "giftCardNumber": "XlQZTmFDFtPFGMxJP6oiAqN3vo+qKZ"
      },
      "createdAt": "2022-07-11T15:03:14.642Z",
      "creditId": "a05b72dc-78d8-4ea4-90fc-2fe6a1fe1111",
      "employeeId": "12312232",
      "note": "Credit request initiated",
      "paymentCounter": 1,
      "policyCode": "RC1",
      "statusCode": "PENDING",
      "subReasonCode": "ACC",
      "updatedAt": "2022-07-11T15:03:14.642Z"
    }
  ]
}

Client Error Response (400)

{
  "errors": [
    {
      "message": "Invalid request",
      "type": "CLIENT_ERROR"
    }
  ],
  "message": "Bad request",
  "type": "CLIENT_ERROR"
}

Unauthorized Error (401)

{
  "message": "Unauthorized request",
  "type": "CLIENT_ERROR"
}

Not Found Error (404)

{
  "message": "Not found",
  "type": "CLIENT_ERROR"
}

Internal Server Error (500)

{
  "message": "Internal server error",
  "type": "SERVER_ERROR"
}

Authorization & Headers

Authorization

Bearer <token>

Headers

Path Parameters